#region using
using System;
using System.Collections;
using System.Collections.Specialized;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Text.RegularExpressions;

using Microsoft.Win32;

using GBPVR.Public;

using RecorderHelper;

using DShowNET;
using DShowNET.Device;
#endregion

namespace SoftwareRecorder
{
	/// <summary>
	/// Summary description for RecorderConfig.
	/// </summary>
	public class RecorderConfig : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		#region Form Variables

		private System.Windows.Forms.ComboBox comboBoxVideoCard;
		private System.Windows.Forms.Label labelVideoCard;
		private System.Windows.Forms.ComboBox comboBoxAudioCard;
		private System.Windows.Forms.ComboBox comboBoxAudioInput;
		private System.Windows.Forms.Label labelAudioCard;
		private System.Windows.Forms.Label labelAudioInput;
		private System.Windows.Forms.Label labelVideoPreview;
		private System.Windows.Forms.ComboBox comboBoxVideoPreview;
		private System.Windows.Forms.Label labelVideoCapture;
		private System.Windows.Forms.ComboBox comboBoxVideoCapture;
		private System.Windows.Forms.Label labelAudioCapture;
		private System.Windows.Forms.ComboBox comboBoxAudioCapture;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.TextBox textBoxConstantChannel;
		private System.Windows.Forms.ComboBox comboBoxVideoStandards;
		private System.Windows.Forms.ComboBox comboBoxTuningType;
		private System.Windows.Forms.Label labelSource;
		private System.Windows.Forms.Label labelConstantChannel;
		private System.Windows.Forms.Label labelVideoStandards;
		private System.Windows.Forms.Label labelTuningType;
		private System.Windows.Forms.Label labelCountry;
		private System.Windows.Forms.Label labelConstantChannelHelp;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.ComboBox comboBoxMuxer;
		private System.Windows.Forms.Label labelMuxer;
		private System.Windows.Forms.Label labelVideoEncoder;
		private System.Windows.Forms.ComboBox comboBoxVideoEncoder;
		private System.Windows.Forms.ComboBox comboBoxAudioEncoder;
		private System.Windows.Forms.Label labelAudioEncoder;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label labelChannelChangeOperation;
		private System.Windows.Forms.ComboBox comboBoxChannelChangeOperation;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Label lblQuality;
		private System.Windows.Forms.Label lblQualityProfile;
		private System.Windows.Forms.ComboBox comboBoxQualityProfile;
		private System.Windows.Forms.Button buttonEdit;
		private System.Windows.Forms.CheckBox checkBoxTuneTwice;
		private System.Windows.Forms.Label labelRecordingStuck;
		private System.Windows.Forms.TextBox textBoxRecordingStuck;
		private System.Windows.Forms.CheckBox checkBoxRenderAudioInPreview;
		private System.Windows.Forms.CheckBox checkBoxRenderVideoToAudio;
		private System.Windows.Forms.Label labelRecordingStuckRestart;
		private System.Windows.Forms.CheckBox checkBoxDoubleRecord;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.ComboBox comboBoxSource0;
		private System.Windows.Forms.ComboBox comboBoxSource1;
		private System.Windows.Forms.ComboBox comboBoxAudioMixer;
		private System.Windows.Forms.Label labelAudioMixer;
		private System.Windows.Forms.ComboBox comboBoxCountry;
		#endregion

		#region Constructor / Destructor
		public RecorderConfig(int captureSourceOID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			captureSource = SoftwareRecorderConfig.getConfigFromMemory(captureSourceOID);
			comboBoxSources = new ComboBox[] { comboBoxSource0, comboBoxSource1 };

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(RecorderConfig));
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.comboBoxVideoCard = new System.Windows.Forms.ComboBox();
			this.labelVideoCard = new System.Windows.Forms.Label();
			this.comboBoxAudioCard = new System.Windows.Forms.ComboBox();
			this.labelAudioCard = new System.Windows.Forms.Label();
			this.comboBoxAudioInput = new System.Windows.Forms.ComboBox();
			this.labelAudioInput = new System.Windows.Forms.Label();
			this.labelVideoPreview = new System.Windows.Forms.Label();
			this.comboBoxVideoPreview = new System.Windows.Forms.ComboBox();
			this.labelVideoCapture = new System.Windows.Forms.Label();
			this.comboBoxVideoCapture = new System.Windows.Forms.ComboBox();
			this.labelAudioCapture = new System.Windows.Forms.Label();
			this.comboBoxAudioCapture = new System.Windows.Forms.ComboBox();
			this.comboBoxSource0 = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.labelSource = new System.Windows.Forms.Label();
			this.textBoxConstantChannel = new System.Windows.Forms.TextBox();
			this.labelConstantChannel = new System.Windows.Forms.Label();
			this.comboBoxVideoStandards = new System.Windows.Forms.ComboBox();
			this.labelVideoStandards = new System.Windows.Forms.Label();
			this.comboBoxTuningType = new System.Windows.Forms.ComboBox();
			this.labelTuningType = new System.Windows.Forms.Label();
			this.comboBoxCountry = new System.Windows.Forms.ComboBox();
			this.labelCountry = new System.Windows.Forms.Label();
			this.labelConstantChannelHelp = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.comboBoxMuxer = new System.Windows.Forms.ComboBox();
			this.labelMuxer = new System.Windows.Forms.Label();
			this.labelVideoEncoder = new System.Windows.Forms.Label();
			this.comboBoxVideoEncoder = new System.Windows.Forms.ComboBox();
			this.comboBoxAudioEncoder = new System.Windows.Forms.ComboBox();
			this.labelAudioEncoder = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.comboBoxChannelChangeOperation = new System.Windows.Forms.ComboBox();
			this.labelChannelChangeOperation = new System.Windows.Forms.Label();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.lblQuality = new System.Windows.Forms.Label();
			this.lblQualityProfile = new System.Windows.Forms.Label();
			this.comboBoxQualityProfile = new System.Windows.Forms.ComboBox();
			this.buttonEdit = new System.Windows.Forms.Button();
			this.checkBoxTuneTwice = new System.Windows.Forms.CheckBox();
			this.labelRecordingStuck = new System.Windows.Forms.Label();
			this.textBoxRecordingStuck = new System.Windows.Forms.TextBox();
			this.labelRecordingStuckRestart = new System.Windows.Forms.Label();
			this.checkBoxRenderAudioInPreview = new System.Windows.Forms.CheckBox();
			this.checkBoxRenderVideoToAudio = new System.Windows.Forms.CheckBox();
			this.checkBoxDoubleRecord = new System.Windows.Forms.CheckBox();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.comboBoxSource1 = new System.Windows.Forms.ComboBox();
			this.comboBoxAudioMixer = new System.Windows.Forms.ComboBox();
			this.labelAudioMixer = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(128, 561);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 50;
			this.buttonOK.Text = "Ok";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(208, 561);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 51;
			this.buttonCancel.Text = "Cancel";
			// 
			// comboBoxVideoCard
			// 
			this.comboBoxVideoCard.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxVideoCard.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxVideoCard.Location = new System.Drawing.Point(120, 12);
			this.comboBoxVideoCard.Name = "comboBoxVideoCard";
			this.comboBoxVideoCard.Size = new System.Drawing.Size(176, 21);
			this.comboBoxVideoCard.Sorted = true;
			this.comboBoxVideoCard.TabIndex = 1;
			this.comboBoxVideoCard.SelectedIndexChanged += new System.EventHandler(this.comboBoxVideoCard_SelectedIndexChanged);
			// 
			// labelVideoCard
			// 
			this.labelVideoCard.Location = new System.Drawing.Point(8, 16);
			this.labelVideoCard.Name = "labelVideoCard";
			this.labelVideoCard.Size = new System.Drawing.Size(112, 13);
			this.labelVideoCard.TabIndex = 0;
			this.labelVideoCard.Text = "Video Capture Card:";
			// 
			// comboBoxAudioCard
			// 
			this.comboBoxAudioCard.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxAudioCard.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxAudioCard.Location = new System.Drawing.Point(120, 72);
			this.comboBoxAudioCard.Name = "comboBoxAudioCard";
			this.comboBoxAudioCard.Size = new System.Drawing.Size(176, 21);
			this.comboBoxAudioCard.Sorted = true;
			this.comboBoxAudioCard.TabIndex = 7;
			this.comboBoxAudioCard.SelectedIndexChanged += new System.EventHandler(this.comboBoxAudioCard_SelectedIndexChanged);
			// 
			// labelAudioCard
			// 
			this.labelAudioCard.Location = new System.Drawing.Point(8, 80);
			this.labelAudioCard.Name = "labelAudioCard";
			this.labelAudioCard.Size = new System.Drawing.Size(112, 13);
			this.labelAudioCard.TabIndex = 6;
			this.labelAudioCard.Text = "Audio Capture Card:";
			// 
			// comboBoxAudioInput
			// 
			this.comboBoxAudioInput.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxAudioInput.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxAudioInput.Location = new System.Drawing.Point(346, 68);
			this.comboBoxAudioInput.Name = "comboBoxAudioInput";
			this.comboBoxAudioInput.Size = new System.Drawing.Size(88, 21);
			this.comboBoxAudioInput.Sorted = true;
			this.comboBoxAudioInput.TabIndex = 9;
			this.comboBoxAudioInput.SelectedIndexChanged += new System.EventHandler(this.comboBoxAudioInput_SelectedIndexChanged);
			// 
			// labelAudioInput
			// 
			this.labelAudioInput.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labelAudioInput.Location = new System.Drawing.Point(296, 72);
			this.labelAudioInput.Name = "labelAudioInput";
			this.labelAudioInput.Size = new System.Drawing.Size(48, 13);
			this.labelAudioInput.TabIndex = 8;
			this.labelAudioInput.Text = "Input:";
			// 
			// labelVideoPreview
			// 
			this.labelVideoPreview.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labelVideoPreview.Location = new System.Drawing.Point(296, 44);
			this.labelVideoPreview.Name = "labelVideoPreview";
			this.labelVideoPreview.Size = new System.Drawing.Size(48, 13);
			this.labelVideoPreview.TabIndex = 4;
			this.labelVideoPreview.Text = "Preview:";
			// 
			// comboBoxVideoPreview
			// 
			this.comboBoxVideoPreview.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxVideoPreview.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxVideoPreview.Location = new System.Drawing.Point(346, 40);
			this.comboBoxVideoPreview.Name = "comboBoxVideoPreview";
			this.comboBoxVideoPreview.Size = new System.Drawing.Size(88, 21);
			this.comboBoxVideoPreview.Sorted = true;
			this.comboBoxVideoPreview.TabIndex = 5;
			// 
			// labelVideoCapture
			// 
			this.labelVideoCapture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labelVideoCapture.Location = new System.Drawing.Point(296, 16);
			this.labelVideoCapture.Name = "labelVideoCapture";
			this.labelVideoCapture.Size = new System.Drawing.Size(48, 13);
			this.labelVideoCapture.TabIndex = 2;
			this.labelVideoCapture.Text = "Capture:";
			// 
			// comboBoxVideoCapture
			// 
			this.comboBoxVideoCapture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxVideoCapture.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxVideoCapture.Location = new System.Drawing.Point(346, 12);
			this.comboBoxVideoCapture.Name = "comboBoxVideoCapture";
			this.comboBoxVideoCapture.Size = new System.Drawing.Size(88, 21);
			this.comboBoxVideoCapture.Sorted = true;
			this.comboBoxVideoCapture.TabIndex = 3;
			// 
			// labelAudioCapture
			// 
			this.labelAudioCapture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labelAudioCapture.Location = new System.Drawing.Point(296, 128);
			this.labelAudioCapture.Name = "labelAudioCapture";
			this.labelAudioCapture.Size = new System.Drawing.Size(48, 13);
			this.labelAudioCapture.TabIndex = 10;
			this.labelAudioCapture.Text = "Capture:";
			// 
			// comboBoxAudioCapture
			// 
			this.comboBoxAudioCapture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxAudioCapture.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxAudioCapture.Location = new System.Drawing.Point(346, 124);
			this.comboBoxAudioCapture.Name = "comboBoxAudioCapture";
			this.comboBoxAudioCapture.Size = new System.Drawing.Size(88, 21);
			this.comboBoxAudioCapture.Sorted = true;
			this.comboBoxAudioCapture.TabIndex = 11;
			// 
			// comboBoxSource0
			// 
			this.comboBoxSource0.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxSource0.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxSource0.Location = new System.Drawing.Point(120, 160);
			this.comboBoxSource0.Name = "comboBoxSource0";
			this.comboBoxSource0.Size = new System.Drawing.Size(176, 21);
			this.comboBoxSource0.TabIndex = 14;
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Location = new System.Drawing.Point(9, 144);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(423, 8);
			this.groupBox1.TabIndex = 12;
			this.groupBox1.TabStop = false;
			// 
			// labelSource
			// 
			this.labelSource.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelSource.Location = new System.Drawing.Point(8, 164);
			this.labelSource.Name = "labelSource";
			this.labelSource.Size = new System.Drawing.Size(112, 13);
			this.labelSource.TabIndex = 13;
			this.labelSource.Text = "Recording Source:";
			// 
			// textBoxConstantChannel
			// 
			this.textBoxConstantChannel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.textBoxConstantChannel.Location = new System.Drawing.Point(120, 272);
			this.textBoxConstantChannel.Name = "textBoxConstantChannel";
			this.textBoxConstantChannel.Size = new System.Drawing.Size(32, 20);
			this.textBoxConstantChannel.TabIndex = 22;
			this.textBoxConstantChannel.Text = "";
			// 
			// labelConstantChannel
			// 
			this.labelConstantChannel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelConstantChannel.Location = new System.Drawing.Point(8, 276);
			this.labelConstantChannel.Name = "labelConstantChannel";
			this.labelConstantChannel.Size = new System.Drawing.Size(112, 13);
			this.labelConstantChannel.TabIndex = 21;
			this.labelConstantChannel.Text = "Constant Channel:";
			// 
			// comboBoxVideoStandards
			// 
			this.comboBoxVideoStandards.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxVideoStandards.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxVideoStandards.Location = new System.Drawing.Point(120, 216);
			this.comboBoxVideoStandards.Name = "comboBoxVideoStandards";
			this.comboBoxVideoStandards.Size = new System.Drawing.Size(176, 21);
			this.comboBoxVideoStandards.TabIndex = 16;
			// 
			// labelVideoStandards
			// 
			this.labelVideoStandards.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelVideoStandards.Location = new System.Drawing.Point(8, 220);
			this.labelVideoStandards.Name = "labelVideoStandards";
			this.labelVideoStandards.Size = new System.Drawing.Size(112, 13);
			this.labelVideoStandards.TabIndex = 15;
			this.labelVideoStandards.Text = "Video Standard:";
			// 
			// comboBoxTuningType
			// 
			this.comboBoxTuningType.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxTuningType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxTuningType.Location = new System.Drawing.Point(346, 244);
			this.comboBoxTuningType.Name = "comboBoxTuningType";
			this.comboBoxTuningType.Size = new System.Drawing.Size(86, 21);
			this.comboBoxTuningType.TabIndex = 20;
			// 
			// labelTuningType
			// 
			this.labelTuningType.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.labelTuningType.Location = new System.Drawing.Point(300, 248);
			this.labelTuningType.Name = "labelTuningType";
			this.labelTuningType.Size = new System.Drawing.Size(64, 13);
			this.labelTuningType.TabIndex = 19;
			this.labelTuningType.Text = "Tuning:";
			// 
			// comboBoxCountry
			// 
			this.comboBoxCountry.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxCountry.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxCountry.Location = new System.Drawing.Point(120, 244);
			this.comboBoxCountry.Name = "comboBoxCountry";
			this.comboBoxCountry.Size = new System.Drawing.Size(176, 21);
			this.comboBoxCountry.TabIndex = 18;
			// 
			// labelCountry
			// 
			this.labelCountry.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelCountry.Location = new System.Drawing.Point(9, 248);
			this.labelCountry.Name = "labelCountry";
			this.labelCountry.Size = new System.Drawing.Size(112, 13);
			this.labelCountry.TabIndex = 17;
			this.labelCountry.Text = "Country:";
			// 
			// labelConstantChannelHelp
			// 
			this.labelConstantChannelHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelConstantChannelHelp.Location = new System.Drawing.Point(160, 276);
			this.labelConstantChannelHelp.Name = "labelConstantChannelHelp";
			this.labelConstantChannelHelp.Size = new System.Drawing.Size(248, 16);
			this.labelConstantChannelHelp.TabIndex = 21;
			this.labelConstantChannelHelp.Text = "(leave blank to use recording source channel)";
			// 
			// groupBox2
			// 
			this.groupBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox2.Location = new System.Drawing.Point(8, 300);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(424, 8);
			this.groupBox2.TabIndex = 12;
			this.groupBox2.TabStop = false;
			// 
			// comboBoxMuxer
			// 
			this.comboBoxMuxer.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxMuxer.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxMuxer.Location = new System.Drawing.Point(120, 372);
			this.comboBoxMuxer.Name = "comboBoxMuxer";
			this.comboBoxMuxer.Size = new System.Drawing.Size(312, 21);
			this.comboBoxMuxer.Sorted = true;
			this.comboBoxMuxer.TabIndex = 18;
			// 
			// labelMuxer
			// 
			this.labelMuxer.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelMuxer.Location = new System.Drawing.Point(8, 376);
			this.labelMuxer.Name = "labelMuxer";
			this.labelMuxer.Size = new System.Drawing.Size(112, 13);
			this.labelMuxer.TabIndex = 17;
			this.labelMuxer.Text = "A/V Muxer:";
			// 
			// labelVideoEncoder
			// 
			this.labelVideoEncoder.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelVideoEncoder.Location = new System.Drawing.Point(8, 320);
			this.labelVideoEncoder.Name = "labelVideoEncoder";
			this.labelVideoEncoder.Size = new System.Drawing.Size(112, 13);
			this.labelVideoEncoder.TabIndex = 13;
			this.labelVideoEncoder.Text = "Video Encoder:";
			// 
			// comboBoxVideoEncoder
			// 
			this.comboBoxVideoEncoder.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxVideoEncoder.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxVideoEncoder.Location = new System.Drawing.Point(120, 316);
			this.comboBoxVideoEncoder.Name = "comboBoxVideoEncoder";
			this.comboBoxVideoEncoder.Size = new System.Drawing.Size(312, 21);
			this.comboBoxVideoEncoder.Sorted = true;
			this.comboBoxVideoEncoder.TabIndex = 14;
			// 
			// comboBoxAudioEncoder
			// 
			this.comboBoxAudioEncoder.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxAudioEncoder.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxAudioEncoder.Location = new System.Drawing.Point(120, 344);
			this.comboBoxAudioEncoder.Name = "comboBoxAudioEncoder";
			this.comboBoxAudioEncoder.Size = new System.Drawing.Size(312, 21);
			this.comboBoxAudioEncoder.Sorted = true;
			this.comboBoxAudioEncoder.TabIndex = 16;
			// 
			// labelAudioEncoder
			// 
			this.labelAudioEncoder.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelAudioEncoder.Location = new System.Drawing.Point(8, 348);
			this.labelAudioEncoder.Name = "labelAudioEncoder";
			this.labelAudioEncoder.Size = new System.Drawing.Size(112, 13);
			this.labelAudioEncoder.TabIndex = 15;
			this.labelAudioEncoder.Text = "Audio Encoder:";
			// 
			// groupBox3
			// 
			this.groupBox3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox3.Location = new System.Drawing.Point(8, 396);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(424, 8);
			this.groupBox3.TabIndex = 12;
			this.groupBox3.TabStop = false;
			// 
			// comboBoxChannelChangeOperation
			// 
			this.comboBoxChannelChangeOperation.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxChannelChangeOperation.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxChannelChangeOperation.Location = new System.Drawing.Point(120, 412);
			this.comboBoxChannelChangeOperation.Name = "comboBoxChannelChangeOperation";
			this.comboBoxChannelChangeOperation.Size = new System.Drawing.Size(312, 21);
			this.comboBoxChannelChangeOperation.TabIndex = 18;
			// 
			// labelChannelChangeOperation
			// 
			this.labelChannelChangeOperation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelChannelChangeOperation.Location = new System.Drawing.Point(8, 416);
			this.labelChannelChangeOperation.Name = "labelChannelChangeOperation";
			this.labelChannelChangeOperation.Size = new System.Drawing.Size(112, 13);
			this.labelChannelChangeOperation.TabIndex = 17;
			this.labelChannelChangeOperation.Text = "On Channel Change:";
			// 
			// groupBox4
			// 
			this.groupBox4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox4.Location = new System.Drawing.Point(8, 464);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(424, 8);
			this.groupBox4.TabIndex = 12;
			this.groupBox4.TabStop = false;
			// 
			// lblQuality
			// 
			this.lblQuality.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblQuality.Location = new System.Drawing.Point(8, 480);
			this.lblQuality.Name = "lblQuality";
			this.lblQuality.Size = new System.Drawing.Size(424, 40);
			this.lblQuality.TabIndex = 17;
			this.lblQuality.Text = "Use the edit button below to modify the default capture settings for each of the " +
				"available quality profiles. The \'medium/default\' profile is always used when you" +
				" do a \'quick record\' .";
			// 
			// lblQualityProfile
			// 
			this.lblQualityProfile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblQualityProfile.Location = new System.Drawing.Point(8, 528);
			this.lblQualityProfile.Name = "lblQualityProfile";
			this.lblQualityProfile.Size = new System.Drawing.Size(128, 13);
			this.lblQualityProfile.TabIndex = 17;
			this.lblQualityProfile.Text = "Quality Profile Settings:";
			// 
			// comboBoxQualityProfile
			// 
			this.comboBoxQualityProfile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.comboBoxQualityProfile.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxQualityProfile.Location = new System.Drawing.Point(136, 524);
			this.comboBoxQualityProfile.Name = "comboBoxQualityProfile";
			this.comboBoxQualityProfile.Size = new System.Drawing.Size(176, 21);
			this.comboBoxQualityProfile.TabIndex = 18;
			// 
			// buttonEdit
			// 
			this.buttonEdit.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.buttonEdit.Location = new System.Drawing.Point(320, 524);
			this.buttonEdit.Name = "buttonEdit";
			this.buttonEdit.TabIndex = 50;
			this.buttonEdit.Text = "Edit";
			this.buttonEdit.Click += new System.EventHandler(this.buttonEdit_Click);
			// 
			// checkBoxTuneTwice
			// 
			this.checkBoxTuneTwice.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBoxTuneTwice.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkBoxTuneTwice.Location = new System.Drawing.Point(300, 220);
			this.checkBoxTuneTwice.Name = "checkBoxTuneTwice";
			this.checkBoxTuneTwice.Size = new System.Drawing.Size(108, 16);
			this.checkBoxTuneTwice.TabIndex = 52;
			this.checkBoxTuneTwice.Text = "Tune Twice";
			this.toolTip1.SetToolTip(this.checkBoxTuneTwice, "Try enabling this if recording doesn\'t initially have sound, but it\'s fine after " +
				"you chanel the channel");
			// 
			// labelRecordingStuck
			// 
			this.labelRecordingStuck.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelRecordingStuck.Location = new System.Drawing.Point(8, 444);
			this.labelRecordingStuck.Name = "labelRecordingStuck";
			this.labelRecordingStuck.Size = new System.Drawing.Size(120, 13);
			this.labelRecordingStuck.TabIndex = 17;
			this.labelRecordingStuck.Text = "Recordings stuck for:";
			// 
			// textBoxRecordingStuck
			// 
			this.textBoxRecordingStuck.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.textBoxRecordingStuck.Location = new System.Drawing.Point(120, 440);
			this.textBoxRecordingStuck.Name = "textBoxRecordingStuck";
			this.textBoxRecordingStuck.Size = new System.Drawing.Size(32, 20);
			this.textBoxRecordingStuck.TabIndex = 22;
			this.textBoxRecordingStuck.Text = "";
			// 
			// labelRecordingStuckRestart
			// 
			this.labelRecordingStuckRestart.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labelRecordingStuckRestart.Location = new System.Drawing.Point(160, 444);
			this.labelRecordingStuckRestart.Name = "labelRecordingStuckRestart";
			this.labelRecordingStuckRestart.Size = new System.Drawing.Size(248, 16);
			this.labelRecordingStuckRestart.TabIndex = 21;
			this.labelRecordingStuckRestart.Text = "seconds, will be automatically restarted";
			// 
			// checkBoxRenderAudioInPreview
			// 
			this.checkBoxRenderAudioInPreview.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkBoxRenderAudioInPreview.Location = new System.Drawing.Point(8, 100);
			this.checkBoxRenderAudioInPreview.Name = "checkBoxRenderAudioInPreview";
			this.checkBoxRenderAudioInPreview.Size = new System.Drawing.Size(256, 16);
			this.checkBoxRenderAudioInPreview.TabIndex = 52;
			this.checkBoxRenderAudioInPreview.Text = "Preview Mode requires Audio to be rendered";
			// 
			// checkBoxRenderVideoToAudio
			// 
			this.checkBoxRenderVideoToAudio.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkBoxRenderVideoToAudio.Location = new System.Drawing.Point(8, 44);
			this.checkBoxRenderVideoToAudio.Name = "checkBoxRenderVideoToAudio";
			this.checkBoxRenderVideoToAudio.Size = new System.Drawing.Size(256, 16);
			this.checkBoxRenderVideoToAudio.TabIndex = 52;
			this.checkBoxRenderVideoToAudio.Text = "Use Video Card as source for Audio Card";
			// 
			// checkBoxDoubleRecord
			// 
			this.checkBoxDoubleRecord.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.checkBoxDoubleRecord.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.checkBoxDoubleRecord.Location = new System.Drawing.Point(300, 192);
			this.checkBoxDoubleRecord.Name = "checkBoxDoubleRecord";
			this.checkBoxDoubleRecord.Size = new System.Drawing.Size(108, 16);
			this.checkBoxDoubleRecord.TabIndex = 52;
			this.checkBoxDoubleRecord.Text = "Double Record";
			this.toolTip1.SetToolTip(this.checkBoxDoubleRecord, "Try enabling this if recording doesn\'t initially have sound, but it\'s fine after " +
				"you chanel the channel");
			// 
			// comboBoxSource1
			// 
			this.comboBoxSource1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxSource1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxSource1.Location = new System.Drawing.Point(120, 188);
			this.comboBoxSource1.Name = "comboBoxSource1";
			this.comboBoxSource1.Size = new System.Drawing.Size(176, 21);
			this.comboBoxSource1.TabIndex = 14;
			// 
			// comboBoxAudioMixer
			// 
			this.comboBoxAudioMixer.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.comboBoxAudioMixer.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxAudioMixer.Location = new System.Drawing.Point(346, 96);
			this.comboBoxAudioMixer.Name = "comboBoxAudioMixer";
			this.comboBoxAudioMixer.Size = new System.Drawing.Size(88, 21);
			this.comboBoxAudioMixer.Sorted = true;
			this.comboBoxAudioMixer.TabIndex = 11;
			// 
			// labelAudioMixer
			// 
			this.labelAudioMixer.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labelAudioMixer.Location = new System.Drawing.Point(296, 100);
			this.labelAudioMixer.Name = "labelAudioMixer";
			this.labelAudioMixer.Size = new System.Drawing.Size(48, 13);
			this.labelAudioMixer.TabIndex = 10;
			this.labelAudioMixer.Text = "Mixer:";
			// 
			// RecorderConfig
			// 
			this.AcceptButton = this.buttonOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(442, 592);
			this.Controls.Add(this.comboBoxTuningType);
			this.Controls.Add(this.labelTuningType);
			this.Controls.Add(this.comboBoxCountry);
			this.Controls.Add(this.labelCountry);
			this.Controls.Add(this.comboBoxVideoStandards);
			this.Controls.Add(this.labelVideoStandards);
			this.Controls.Add(this.textBoxConstantChannel);
			this.Controls.Add(this.textBoxRecordingStuck);
			this.Controls.Add(this.labelConstantChannel);
			this.Controls.Add(this.comboBoxSource0);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.labelSource);
			this.Controls.Add(this.comboBoxVideoCard);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.comboBoxAudioCard);
			this.Controls.Add(this.comboBoxAudioInput);
			this.Controls.Add(this.labelAudioInput);
			this.Controls.Add(this.labelVideoPreview);
			this.Controls.Add(this.comboBoxVideoPreview);
			this.Controls.Add(this.labelVideoCapture);
			this.Controls.Add(this.comboBoxVideoCapture);
			this.Controls.Add(this.labelAudioCapture);
			this.Controls.Add(this.comboBoxAudioCapture);
			this.Controls.Add(this.labelVideoCard);
			this.Controls.Add(this.labelAudioCard);
			this.Controls.Add(this.labelConstantChannelHelp);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.comboBoxMuxer);
			this.Controls.Add(this.comboBoxVideoEncoder);
			this.Controls.Add(this.comboBoxAudioEncoder);
			this.Controls.Add(this.labelMuxer);
			this.Controls.Add(this.labelVideoEncoder);
			this.Controls.Add(this.labelAudioEncoder);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.comboBoxChannelChangeOperation);
			this.Controls.Add(this.labelChannelChangeOperation);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.lblQuality);
			this.Controls.Add(this.lblQualityProfile);
			this.Controls.Add(this.comboBoxQualityProfile);
			this.Controls.Add(this.buttonEdit);
			this.Controls.Add(this.checkBoxTuneTwice);
			this.Controls.Add(this.labelRecordingStuckRestart);
			this.Controls.Add(this.labelRecordingStuck);
			this.Controls.Add(this.checkBoxRenderAudioInPreview);
			this.Controls.Add(this.checkBoxRenderVideoToAudio);
			this.Controls.Add(this.checkBoxDoubleRecord);
			this.Controls.Add(this.comboBoxSource1);
			this.Controls.Add(this.comboBoxAudioMixer);
			this.Controls.Add(this.labelAudioMixer);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "RecorderConfig";
			this.ShowInTaskbar = false;
			this.Text = "Software Recorder Configuration";
			this.Load += new System.EventHandler(this.RecorderConfig_Load);
			this.Closed += new System.EventHandler(this.RecorderConfig_Closed);
			this.ResumeLayout(false);

		}
		#endregion

		#region Private Variables
		private SoftwareRecorderConfig captureSource;
		private Hashtable countriesHashtable = new Hashtable();
		private ArrayList multiCrossbarsRoutings;
		private ArrayList mediaTypes;
		private DsUtils.DsAMMediaType defaultMediaType;
		private Hashtable qualityProfiles = new Hashtable();
		private ComboBox[] comboBoxSources;
		#endregion

		#region Loading
		private void RecorderConfig_Load(object sender, System.EventArgs e)
		{
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: enter RecorderConfig.Load()");

			if (((Environment.OSVersion.Version.Major > 4) & (Environment.OSVersion.Version.Minor > 0)) & File.Exists(Application.ExecutablePath + ".manifest"))
			{
				for (int i = 0; i < Controls.Count; i++)
				{
					if (Controls[i].GetType().BaseType == typeof(ButtonBase))
					{
						((ButtonBase)Controls[i]).FlatStyle = FlatStyle.System;
					}
				}
			}
			
			if (captureSource == null) 
			{
				MessageBox.Show("Please save the capture source first, then you can configure it's settings");
				this.DialogResult = DialogResult.OK;
				this.Close();
				return;
			}
			
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Checking for correct DirectX version");
			if( ! DsUtils.IsCorrectDirectXVersion() )
			{
				throw new Exception("DirectX 8.1 NOT installed!");
			}

			// ******************************** Audio/Video Input Devices ********************************

			/// <summary> list of installed video devices. </summary>
			ArrayList videoCapDevices;
			
			/// <summary> list of installed audio devices. </summary>
			ArrayList audioCapDevices;

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: GetDevicesOfCat:VideoInputDevice");
			if( ! DsDev.GetDevicesOfCat( FilterCategory.VideoInputDevice, out videoCapDevices ) )
				throw new Exception("No video capture devices found!");
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: GetDevicesOfCat:AudioInputDevice");
			if( ! DsDev.GetDevicesOfCat( FilterCategory.AudioInputDevice, out audioCapDevices ) )
				throw new Exception("No audio capture devices found!");

			// ******************************** Video Input ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Parsing VideoInputDevices");
			if (videoCapDevices != null)
			{
				foreach( DsDevice d in videoCapDevices )
				{
					string exceptionReason = "Failed to find exception reason";

					try 
					{
						exceptionReason = "Failed to get devUniqueDeviceIdentifier";
						string devUniqueDeviceIdentifier = d.GetDisplayName();
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Found Video: " + devUniqueDeviceIdentifier);

						exceptionReason = "Failed to add device to list";
						comboBoxVideoCard.Items.Add( d );
						audioCapDevices.Add(d);

						exceptionReason = "Failed to select default device in list";
						if (devUniqueDeviceIdentifier == captureSource.uniqueVideoDeviceIdentifier) 
						{
							comboBoxVideoCard.SelectedItem = d;
							foreach ( DsUtils.DsPin p in comboBoxVideoCapture.Items )
								if (p.Name == captureSource.uniqueVideoDeviceCapture)
									comboBoxVideoCapture.SelectedItem = p;
							foreach ( DsUtils.DsPin p in comboBoxVideoPreview.Items )
								if (p.Name == captureSource.uniqueVideoDevicePreview)
									comboBoxVideoPreview.SelectedItem = p;
						}
					}
					catch (Exception ex)
					{
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: " + exceptionReason + ": " + ex.ToString());
					}

				}
			}

			// ******************************** Audio Input ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Parsing AudioInputDevices");
			if (audioCapDevices != null) 
			{
				foreach( DsDevice d in audioCapDevices )
				{
					comboBoxAudioCard.Items.Add( d );

					string devUniqueDeviceIdentifier = d.GetDisplayName();

					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Found Audio: " + devUniqueDeviceIdentifier);
					
					if (devUniqueDeviceIdentifier == captureSource.uniqueAudioDeviceIdentifier) 
					{
						comboBoxAudioCard.SelectedItem = d;
						foreach ( DsUtils.DsPin p in comboBoxAudioInput.Items )
							if (p.Name == captureSource.uniqueAudioDeviceSource)
								comboBoxAudioInput.SelectedItem = p;
						foreach ( DsUtils.DsPin p in comboBoxAudioCapture.Items )
							if (p.Name == captureSource.uniqueAudioDeviceCapture)
								comboBoxAudioCapture.SelectedItem = p;
					}
				}
			}
			comboBoxAudioMixer.Text = captureSource.uniqueAudioDeviceMixer;

			// ******************************** Tuning Types ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: loading tuning types");
			
			foreach (string tuningType in Enum.GetNames(typeof(TunerInputType)))
			{
				comboBoxTuningType.Items.Add(tuningType);
			}
			comboBoxTuningType.SelectedIndex = (int)captureSource.tuningType;
			if ((comboBoxTuningType.Items.Count > 0) && (comboBoxTuningType.SelectedIndex == -1))
			{
				comboBoxTuningType.SelectedIndex = 0;
			}

			// ******************************** Countries ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: loading countries");

			try 
			{
				// try and load the list of countries from the registry
				RegistryKey CountryList = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Telephony\Country List");
				try
				{
					foreach (string CountryName in CountryList.GetSubKeyNames())
					{
						RegistryKey Country = CountryList.OpenSubKey(CountryName);
						try
						{
							if (Path.GetFileName(Country.Name) == Country.GetValue("CountryCode").ToString())
								countriesHashtable[Country.GetValue("Name")] = Country.GetValue("CountryCode");
						}
						finally 
						{
							Country.Close();
						}
					}
				}
				finally 
				{
					CountryList.Close();
				}
			}
			catch 
			{
				// something went wrong, let's just load a short list of known countries
				countriesHashtable.Clear();
				countriesHashtable["Argentina"]		 = 54;
				countriesHashtable["Australia"]		 = 61;
				countriesHashtable["Austria"]		 = 43;
				countriesHashtable["Belgium"]		 = 32;
				countriesHashtable["Canada"]		 = 2; 
				countriesHashtable["China"]			 = 86;
				countriesHashtable["Chile"]			 = 56;
				countriesHashtable["Denmark"]		 = 45;
				countriesHashtable["Finland"]		 = 358;
				countriesHashtable["France"]		 = 33;
				countriesHashtable["Germany"]		 = 49;
				countriesHashtable["Greece"]		 = 30;
				countriesHashtable["India"]			 = 91;
				countriesHashtable["Italy"]			 = 39;
				countriesHashtable["Japan"]			 = 81;
				countriesHashtable["Korea"]			 = 82;
				countriesHashtable["Malaysia"]		 = 60;
				countriesHashtable["Netherlands"]	 = 31;
				countriesHashtable["New Zealand"]	 = 64;
				countriesHashtable["Norway"]		 = 47;
				countriesHashtable["Russia"]		 = 7;
				countriesHashtable["Poland"]		 = 48;
				countriesHashtable["Spain"]			 = 34;
				countriesHashtable["Singapore"]		 = 65;
				countriesHashtable["South Africa"]	 = 27;
				countriesHashtable["Sweden"]		 = 46;
				countriesHashtable["Switzerland"]	 = 41;
				countriesHashtable["Thailand"]		 = 66;
				countriesHashtable["United Kingdom"] = 44;
				countriesHashtable["USA"]			 = 1;
			}

			comboBoxCountry.Sorted = true;
			foreach (string country in countriesHashtable.Keys)
			{
				int index = comboBoxCountry.Items.Add(country);
				if ((int)countriesHashtable[country] == captureSource.countryCode)
					comboBoxCountry.SelectedIndex = index;
			}

			// ******************************** Constant Channel ********************************

			if (captureSource.fixedChannel != 0)
				textBoxConstantChannel.Text = captureSource.fixedChannel.ToString();
			else
				textBoxConstantChannel.Text = string.Empty;

			// ******************************** Recording Tweaks ********************************

			checkBoxRenderVideoToAudio.Checked = captureSource.videoIsAudioSource;
			checkBoxRenderAudioInPreview.Checked = captureSource.audioRendersInPreview;
			checkBoxDoubleRecord.Checked = captureSource.startRecordTwice;
			checkBoxTuneTwice.Checked = captureSource.tuneTwice;
			textBoxRecordingStuck.Text = captureSource.stuckTimeout.ToString();

			// ******************************** Encoders ********************************

			/// <summary> list of installed video devices. </summary>
			ArrayList encoderDevices;

			Config config = Config.getConfig();
			string videoEncoderRegexString	= config.GetSetting(this, "VideoEncoderRegex");
			string audioEncoderRegexString	= config.GetSetting(this, "AudioEncoderRegex");
			string muxerRegexString			= config.GetSetting(this, "MuxerRegex");

			if (videoEncoderRegexString == null)	videoEncoderRegexString = string.Empty;
			if (audioEncoderRegexString == null)	audioEncoderRegexString = string.Empty;
			if (muxerRegexString		== null)	muxerRegexString		= string.Empty;

			Regex videoEncoderRegex = new Regex(videoEncoderRegexString	, RegexOptions.Compiled | RegexOptions.IgnoreCase);
			Regex audioEncoderRegex = new Regex(audioEncoderRegexString	, RegexOptions.Compiled | RegexOptions.IgnoreCase);
			Regex muxerRegex		= new Regex(muxerRegexString		, RegexOptions.Compiled | RegexOptions.IgnoreCase);
			
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: GetDevicesByMatch:Encoders");
			if( ! DsDev.GetDevicesByMatch(false, Merit.SW_Compressor, 
				true, new Guid[] {}, Guid.Empty, 
				false, 
				true, new Guid[] {}, Guid.Empty, 
				out encoderDevices) )
				throw new Exception("No video encoder devices found!");
			
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Parsing EncodingDevices");
			if (encoderDevices != null)
			{
				foreach( DsDevice d in encoderDevices )
				{
					string exceptionReason = "Failed to find exception reason";

					try 
					{
						exceptionReason = "Failed to get devUniqueDeviceIdentifier";
						string devUniqueDeviceIdentifier = d.GetDisplayName();
						//Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Found Video: " + devUniqueDeviceIdentifier);

						exceptionReason = "Failed to add device to list";
						if ((d.Name != null) && (d.Name.Length > 0) && (videoEncoderRegexString.Length > 0) && (videoEncoderRegex.IsMatch(d.Name)))
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: EncodingDevices-Video Encoder=" + d.Name);
							comboBoxVideoEncoder.Items.Add( d );
							exceptionReason = "Failed to select default device in list";
							if (devUniqueDeviceIdentifier == captureSource.uniqueVideoEncoderIdentifier) 
							{
								comboBoxVideoEncoder.SelectedItem = d;
							}
						}
						else if ((d.Name != null) && (d.Name.Length > 0) && (audioEncoderRegexString.Length > 0) && (audioEncoderRegex.IsMatch(d.Name)))
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: EncodingDevices-Audio Encoder=" + d.Name);
							comboBoxAudioEncoder.Items.Add( d );
							exceptionReason = "Failed to select default device in list";
							if (devUniqueDeviceIdentifier == captureSource.uniqueAudioEncoderIdentifier) 
							{
								comboBoxAudioEncoder.SelectedItem = d;
							}
						}
						else if ((d.Name != null) && (d.Name.Length > 0) && (muxerRegexString.Length > 0) && (muxerRegex.IsMatch(d.Name)))
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: EncodingDevices-Muxer=" + d.Name);
							comboBoxMuxer.Items.Add( d );
							exceptionReason = "Failed to select default device in list";
							if (devUniqueDeviceIdentifier == captureSource.uniqueMuxerIdentifier) 
							{
								comboBoxMuxer.SelectedItem = d;
							}
						} 
						else
						{
							d.Dispose();
						}

					}
					catch (Exception ex)
					{
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: " + exceptionReason + ": " + ex.ToString());
					}

				}
			}

			if ((comboBoxVideoEncoder.Items.Count > 0) && (comboBoxVideoEncoder.SelectedIndex == -1))
			{
				comboBoxVideoEncoder.SelectedIndex = 0;
			}
			if ((comboBoxAudioEncoder.Items.Count > 0) && (comboBoxAudioEncoder.SelectedIndex == -1))
			{
				comboBoxAudioEncoder.SelectedIndex = 0;
			}
			if ((comboBoxMuxer.Items.Count > 0) && (comboBoxMuxer.SelectedIndex == -1))
			{
				comboBoxMuxer.SelectedIndex = 0;
			}

			// ******************************** Channel Change Operation ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: loading channel change operation");
			
			foreach (string channelChangeOperation in Enum.GetNames(typeof(ChannelChangeOperation)))
			{
				comboBoxChannelChangeOperation.Items.Add(channelChangeOperation);
			}
			comboBoxChannelChangeOperation.SelectedIndex = (int)captureSource.channelChangeOperation;
			if ((comboBoxChannelChangeOperation.Items.Count > 0) && (comboBoxChannelChangeOperation.SelectedIndex == -1))
			{
				comboBoxChannelChangeOperation.SelectedIndex = 0;
			}

			// ******************************** Quality Profiles ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: loading quality profiles");

			foreach (string scheduledRecordingQuality in Enum.GetNames(typeof(ScheduledRecording_Quality)))
			{
				comboBoxQualityProfile.Items.Add(scheduledRecordingQuality + " Quality");
			}
			comboBoxQualityProfile.SelectedIndex = (int)ScheduledRecording_Quality.Medium;
			qualityProfiles = captureSource.qualityProfiles;

			// ******************************** End ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: exit RecorderConfig.Load");
		}
		#endregion

		#region Unloading
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			if ((comboBoxVideoCard.SelectedItem == comboBoxAudioCard.SelectedItem) &&
				((comboBoxVideoCapture.Text == comboBoxAudioCapture.Text) ||
				(comboBoxVideoPreview.Text == comboBoxAudioCapture.Text)))
			{
				MessageBox.Show("You can't use the same capture pin for Video and Audio at the same time!");
				DialogResult = DialogResult.None;
				return;
			}

			DsDevice	  videoDevice						= (DsDevice)comboBoxVideoCard.SelectedItem;
			captureSource.uniqueVideoDeviceIdentifier		= videoDevice != null ? videoDevice.GetDisplayName() : string.Empty;
			DsUtils.DsPin videoCapturePin = ((DsUtils.DsPin)comboBoxVideoCapture.SelectedItem);
			captureSource.uniqueVideoDeviceCapture			= videoCapturePin != null ? videoCapturePin.Name : string.Empty;
			captureSource.uniqueVideoDeviceCaptureCategory	= videoCapturePin != null ? videoCapturePin.Category : Guid.Empty;
			captureSource.uniqueVideoDevicePreview			= comboBoxVideoPreview.Text;
			
			DsDevice	  audioDevice						= (DsDevice)comboBoxAudioCard.SelectedItem;
			captureSource.uniqueAudioDeviceIdentifier		= audioDevice != null ? audioDevice.GetDisplayName() : string.Empty;
			captureSource.uniqueAudioDeviceSource			= comboBoxAudioInput.Text;
			DsUtils.DsPin audioCapturePin = ((DsUtils.DsPin)comboBoxAudioCapture.SelectedItem);
			captureSource.uniqueAudioDeviceCapture			= audioCapturePin != null ? audioCapturePin.Name : string.Empty;
			captureSource.uniqueAudioDeviceCaptureCategory	= audioCapturePin != null ? audioCapturePin.Category : Guid.Empty;
			captureSource.uniqueAudioDeviceMixer			= comboBoxAudioMixer.Text;

			ArrayList configRoutings = new ArrayList();
			for (int c = 0; c < comboBoxSources.Length; c++)
			{
				ComboBox comboBoxSource = comboBoxSources[c];

				if (c < multiCrossbarsRoutings.Count)
				{
					Hashtable crossbarRoutings = (Hashtable)multiCrossbarsRoutings[c];

					ArrayList keys = new ArrayList(crossbarRoutings.Keys);
					keys.Sort();
					ArrayList routings = new ArrayList();
					foreach (string key in keys) 
					{
						if (comboBoxSource.Text == (string)crossbarRoutings[key])
							routings.Add(key);
					}
					configRoutings.Add(string.Join(",", (string[])routings.ToArray(typeof(string))));
				}
			}
			captureSource.crossbarRoutings				= string.Join(";", (string[])configRoutings.ToArray(typeof(string)));

			captureSource.videoStandard					= comboBoxVideoStandards.Text.Length > 0 ? (AnalogVideoStandard	)Enum.Parse(typeof(AnalogVideoStandard	), comboBoxVideoStandards.Text) : AnalogVideoStandard.None;
			captureSource.countryCode					= (int)countriesHashtable[comboBoxCountry.Text];
			captureSource.tuningType					= (TunerInputType)Enum.Parse(typeof(TunerInputType), comboBoxTuningType.Text);
			captureSource.fixedChannel					= textBoxConstantChannel.Text.Length > 0 ? Convert.ToInt32(textBoxConstantChannel.Text) : 0;

			captureSource.videoIsAudioSource			= checkBoxRenderVideoToAudio.Checked;
			captureSource.audioRendersInPreview			= checkBoxRenderAudioInPreview.Checked;
			
			captureSource.startRecordTwice				= checkBoxDoubleRecord.Checked;
			captureSource.tuneTwice						= checkBoxTuneTwice.Checked;
			captureSource.stuckTimeout					= Convert.ToInt32(textBoxRecordingStuck.Text);

			DsDevice	  videoEncoder					= (DsDevice)comboBoxVideoEncoder.SelectedItem;
			captureSource.uniqueVideoEncoderIdentifier	= videoEncoder	!= null ? videoEncoder.GetDisplayName()	: string.Empty;
			DsDevice	  audioEncoder					= (DsDevice)comboBoxAudioEncoder.SelectedItem;
			captureSource.uniqueAudioEncoderIdentifier	= audioEncoder	!= null ? audioEncoder.GetDisplayName()	: string.Empty;
			DsDevice	  muxer							= (DsDevice)comboBoxMuxer.SelectedItem;
			captureSource.uniqueMuxerIdentifier			= muxer			!= null ? muxer.GetDisplayName()		: string.Empty;

			captureSource.channelChangeOperation		= (ChannelChangeOperation)Enum.Parse(typeof(ChannelChangeOperation), comboBoxChannelChangeOperation.Text);

			captureSource.qualityProfiles				= qualityProfiles;
		}

		private void RecorderConfig_Closed(object sender, System.EventArgs e)
		{
			foreach( DsDevice d in comboBoxVideoCard.Items )
				d.Dispose();
			foreach ( DsUtils.DsPin p in comboBoxVideoCapture.Items )
				p.Dispose();

			foreach( DsDevice d in comboBoxAudioCard.Items )
				d.Dispose();
			foreach ( DsUtils.DsPin p in comboBoxAudioInput.Items )
				p.Dispose();
			foreach ( DsUtils.DsPin p in comboBoxAudioCapture.Items )
				p.Dispose();

			foreach( DsDevice d in comboBoxVideoEncoder.Items )
				d.Dispose();
			foreach( DsDevice d in comboBoxAudioEncoder.Items )
				d.Dispose();
			foreach( DsDevice d in comboBoxMuxer.Items )
				d.Dispose();
		}
		#endregion

		#region ComboBox Selected Index Changed
		private void comboBoxVideoCard_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			checkIfVideoAndAudioMatch();
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: enter VideoCard.SelectedIndexChanged()");

			DsDevice d = (DsDevice)comboBoxVideoCard.SelectedItem;

			foreach ( DsUtils.DsPin p in comboBoxVideoCapture.Items )
				p.Dispose();
			comboBoxVideoCapture.Items.Clear();
			comboBoxVideoPreview.Items.Clear();

			object comObj = null;
			IBaseFilter baseFilter = null;
			try
			{
				// ******************************** Pins ********************************

				comObj = d.BindToObject(typeof(IBaseFilter));
				baseFilter = comObj as IBaseFilter; comObj = null;
				if (baseFilter != null) 
				{
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IBaseFilter.GetPins(Output)");

					ArrayList pins;
					DsUtils.GetPins(baseFilter, PinDirection.Output, out pins);

					if (pins != null) 
					{
						DsUtils.DsPin defaultCapturePin = null;
						DsUtils.DsPin defaultPreviewPin = null;
						foreach (DsUtils.DsPin pin in pins) 
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: pin: " + pin.Name + ": category=" + GuidHelper.GetGuidName(typeof(PinCategory), pin.Category));
							comboBoxVideoCapture.Items.Add(pin);
							comboBoxVideoPreview.Items.Add(pin);
							if (pin.Name == "Capture") defaultCapturePin = pin;
							if (pin.Name == "Preview") defaultPreviewPin = pin;
							if ((pin.Name == "Capture") && (defaultPreviewPin == null)) defaultPreviewPin = pin;
						}
						comboBoxVideoCapture.SelectedItem = defaultCapturePin;
						comboBoxVideoPreview.SelectedItem = defaultPreviewPin;
					}
				}
				else
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IBaseFilter not found");

				// ******************************** TV Formats ********************************

				IAMAnalogVideoDecoder analogVideoDecoder = baseFilter as IAMAnalogVideoDecoder;
				if (analogVideoDecoder != null) 
				{
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IAMAnalogVideoDecoder.get_AvailableTVFormats");
					AnalogVideoStandard videoStandards;
					analogVideoDecoder.get_AvailableTVFormats(out videoStandards);
					comboBoxVideoStandards.Items.Clear();
					foreach (AnalogVideoStandard standard in Enum.GetValues(typeof(AnalogVideoStandard)))
					{
						if ((videoStandards & standard) != 0)
						{
							int index = comboBoxVideoStandards.Items.Add(standard.ToString());
							if (standard == captureSource.videoStandard) 
								comboBoxVideoStandards.SelectedIndex = index;
						}
					}
					if ((comboBoxVideoStandards.Items.Count > 0) && (comboBoxVideoStandards.SelectedIndex == -1))
					{
						comboBoxVideoStandards.SelectedIndex = 0;
					}
				}
				else
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IAMAnalogVideoDecoder not found");

				// ******************************** Media Types ********************************

				Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: getting media types");
				
				IPin pPin;
				DsUtils.GetPin(baseFilter, PinDirection.Output, 0, out pPin);
				IAMStreamConfig streamConfig = pPin as IAMStreamConfig;
				if (streamConfig != null)
				{
					DsUtils.GetStreamCaps(streamConfig, out mediaTypes);
					DsUtils.GetFormat(streamConfig, out defaultMediaType);
	
					foreach (DsUtils.DsAMMediaType mediaType in mediaTypes)
					{
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: mediatype: " + 
							"majorType=" + GuidHelper.GetGuidName(typeof(MediaType), mediaType.MediaType.majorType) + ", " + 
							"subType=" + GuidHelper.GetGuidName(typeof(MediaSubType), mediaType.MediaType.subType) + ", " + 
							"formatType=" + GuidHelper.GetGuidName(typeof(FormatType), mediaType.MediaType.formatType) + ", " + 
							"size=" + mediaType.videoStreamConfigCaps.MinOutputSize.X + "x" + mediaType.videoStreamConfigCaps.MinOutputSize.Y + 
							" -> " + mediaType.videoStreamConfigCaps.MaxOutputSize.X + "x" + mediaType.videoStreamConfigCaps.MaxOutputSize.Y + 
							" (" + mediaType.videoInfoHeader.BmiHeader.Width + "x" + mediaType.videoInfoHeader.BmiHeader.Height + " default, " + 
							"steps of " + mediaType.videoStreamConfigCaps.OutputGranularityX + "x" + mediaType.videoStreamConfigCaps.OutputGranularityY + ")");
					}
				} else {
					buttonEdit.Enabled = false;
				}

				// ******************************** Recording Source ********************************

				Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: getting recording sources");

				Type					comType			= null;
				IGraphBuilder			graphBuilder	= null;
				ICaptureGraphBuilder2	capGraph		= null;
				try 
				{
					comType = Type.GetTypeFromCLSID( Clsid.FilterGraph );
					if( comType == null )
						throw new NotImplementedException( @"DirectShow FilterGraph not installed/registered!" );
					comObj = Activator.CreateInstance( comType );
					graphBuilder = (IGraphBuilder) comObj; comObj = null;

					comType = Type.GetTypeFromCLSID( Clsid.CaptureGraphBuilder2 );
					if( comType == null )
						throw new NotImplementedException( @"DirectShow CaptureGraphBuilder2 not installed/registered!" );
					comObj = Activator.CreateInstance( comType );
					capGraph = (ICaptureGraphBuilder2) comObj; comObj = null;

					int hr = capGraph.SetFiltergraph( graphBuilder );
					if( hr < 0 ) 
					{
						Marshal.ThrowExceptionForHR( hr );
					}

					// add video capture device
					hr = graphBuilder.AddFilter( baseFilter, "Video Capture Device" );
					if( hr < 0 ) 
					{
						Marshal.ThrowExceptionForHR( hr );
					}

					multiCrossbarsRoutings = new ArrayList();
					ArrayList crossbars = new ArrayList();

					try
					{
						Hashtable routings;
						IBaseFilter searchFilter = baseFilter;
						IBaseFilter crossbar = null;
						for (int i = 0; i < 2; i++) // When your graph has several crossbars, something's wrong [k's choice]
						{
							routings = getRoutings(capGraph, searchFilter, out crossbar);
							if (routings != null) 
							{
								multiCrossbarsRoutings.Add(routings);
								crossbars.Add(crossbar);
								searchFilter = crossbar;
							}
							else
								break;
						}
					}
					finally
					{
						foreach (object crossbar in (ArrayList)crossbars.Clone())
							try 
							{
								Marshal.ReleaseComObject( crossbar ); crossbars.Remove(crossbar);
							}
							catch {}
					}
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Found " + multiCrossbarsRoutings.Count.ToString() + " crossbar" + (multiCrossbarsRoutings.Count == 1 ? "" : "s"));

				}
				finally
				{
					if( capGraph != null )
						Marshal.ReleaseComObject( capGraph ); capGraph = null;
					if( graphBuilder != null )
						Marshal.ReleaseComObject( graphBuilder ); graphBuilder = null;
				}

				for (int c = 0; c < comboBoxSources.Length; c++)
				{
					ComboBox comboBoxSource = comboBoxSources[c];

					if (c < multiCrossbarsRoutings.Count)
					{
						Hashtable crossbarRoutings = (Hashtable)multiCrossbarsRoutings[c];
						comboBoxSource.Items.Clear();
						comboBoxSource.Enabled = true;

						ArrayList keys = new ArrayList(crossbarRoutings.Keys);
						keys.Sort();
						foreach (string key in keys)
						{
							if (!comboBoxSource.Items.Contains(crossbarRoutings[key])) 
							{
								int index = comboBoxSource.Items.Add(crossbarRoutings[key]);
								if ((captureSource.crossbarRoutings != null) && (captureSource.crossbarRoutings.Split(',')[0] == key))
									comboBoxSource.SelectedIndex = index;
							}
						}

						if ((comboBoxSource.Items.Count > 0) && (comboBoxSource.SelectedIndex == -1))
						{
							comboBoxSource.SelectedIndex = 0;
						}
					}
					else
					{
						comboBoxSource.Items.Clear();
						comboBoxSource.Enabled = false;
					}
				}

				// ******************************** Finished ********************************

			}
			finally 
			{
				if( comObj != null )
					Marshal.ReleaseComObject(comObj); comObj = null;
				if( baseFilter != null )
					Marshal.ReleaseComObject(baseFilter); baseFilter = null;
			}

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: exit VideoCard.SelectedIndexChanged");
		}

		private Hashtable getRoutings(ICaptureGraphBuilder2 capGraph, IBaseFilter crossbarSource, out IBaseFilter crossbarFilter)
		{
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: FindInterface(IAMCrossbar)");

			object comObj = null;
			crossbarFilter = null;

			try
			{
				// find the crossbar - with WDM drivers this should add it automatically to graph for us
				Guid cat  = LookOnly.Upstream;
				Guid type = Guid.Empty;
				Guid iid = typeof( IAMCrossbar ).GUID;
				int hr = capGraph.FindInterface( ref cat, ref type, crossbarSource, ref iid, out comObj );
				if( hr < 0 ) 
				{
					return null;//Marshal.ThrowExceptionForHR( hr );
				}
				IAMCrossbar crossbar = comObj as IAMCrossbar; comObj = null;
				crossbarFilter = (IBaseFilter)crossbar;

				int outPinCount;
				int inPinCount;
				crossbar.get_PinCounts(out outPinCount, out inPinCount);

				Hashtable crossbarRoutings = new Hashtable();

				for (int o = 0; o < outPinCount; o++)
				{
					int oRelatedPin;
					PhysicalConnectorType oPinType;
					hr = crossbar.get_CrossbarPinInfo(0, o, out oRelatedPin, out oPinType);
					for (int i = 0; i < inPinCount; i++)
					{
						if (crossbar.CanRoute(o, i) == 0)
						{
							int iRelatedPin;
							int xRelatedPin;
							PhysicalConnectorType pinType0;
							PhysicalConnectorType pinType1;
							hr  = crossbar.get_CrossbarPinInfo(1, i, out iRelatedPin, out pinType0);
							if ((hr == 0) && (!crossbarRoutings.Contains(i.ToString() + "-" + o.ToString())))
							{
								// iRelatedPin = -1;
								if (iRelatedPin >= 0) 
								{
									hr = crossbar.get_CrossbarPinInfo(1, iRelatedPin, out xRelatedPin, out pinType1);
								
									string description = pinType0.ToString().Replace("_", ":") + ", " + pinType1.ToString().Replace("_", ":");
									crossbarRoutings[i.ToString() + "-" + o.ToString()] = description;
									crossbarRoutings[iRelatedPin.ToString() + "-" + oRelatedPin.ToString()] = description;
									
									Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Crossbar Mapping: " + i.ToString() + "-" + o.ToString() + ":" + pinType0.ToString().Replace("_", ":") + ", " + iRelatedPin.ToString() + "-" + oRelatedPin.ToString() + ":" + pinType1.ToString().Replace("_", ":"));
								}
								else
								{
									string description = pinType0.ToString().Replace("_", ":");
									crossbarRoutings[i.ToString() + "-" + o.ToString()] = description;

									Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Crossbar Mapping: " + i.ToString() + "-" + o.ToString() + ":" + pinType0.ToString().Replace("_", ":"));
								}
							}
						}
					}
				}
			
				return crossbarRoutings;

			}
			finally
			{
				if( comObj != null )
					Marshal.ReleaseComObject( comObj ); comObj = null;
			}
		}

		private void comboBoxAudioCard_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			checkIfVideoAndAudioMatch();
			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: enter AudioCard.SelectedIndexChanged()");

			DsDevice d = (DsDevice)comboBoxAudioCard.SelectedItem;

			object comObj = d.BindToObject(typeof(IBaseFilter));

			// ******************************** Pins ********************************

			foreach ( DsUtils.DsPin p in comboBoxAudioInput.Items )
				p.Dispose();
			foreach ( DsUtils.DsPin p in comboBoxAudioCapture.Items )
				p.Dispose();
			comboBoxAudioInput.Items.Clear();
			comboBoxAudioCapture.Items.Clear();

			ArrayList pins;

			// ******************************** Input Pins ********************************

			if (!comboBoxVideoCard.Items.Contains(comboBoxAudioCard.SelectedItem))
			{
				Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IBaseFilter.GetPins(Input)");

				// audio capture devices - we look at the input pins
				DsUtils.GetPins((IBaseFilter)comObj, PinDirection.Input, out pins);

				if (pins != null)
				{
					DsUtils.DsPin defaultPin = null;
					foreach (DsUtils.DsPin pin in pins)
					{
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: pin: " + pin.Name + ": category=" + GuidHelper.GetGuidName(typeof(PinCategory), pin.Category));
						comboBoxAudioInput.Items.Add(pin);
						if (pin.Name == "Line In") defaultPin = pin;
					}
					comboBoxAudioInput.SelectedItem = defaultPin;
				}
			}

			// ******************************** Output Pins ********************************

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: IBaseFilter.GetPins(Output)");

			// all capture devices - we look at the output pins
			DsUtils.GetPins((IBaseFilter)comObj, PinDirection.Output, out pins);

			if (pins != null) 
			{
				DsUtils.DsPin defaultPin = null;
				foreach (DsUtils.DsPin pin in pins) 
				{
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: pin: " + pin.Name + ": category=" + GuidHelper.GetGuidName(typeof(PinCategory), pin.Category));
					comboBoxAudioCapture.Items.Add(pin);
					if (pin.Name == "Audio") defaultPin = pin;
					if ((pin.Name == "Capture") && (defaultPin == null)) defaultPin = pin;
				}
				comboBoxAudioCapture.SelectedItem = defaultPin;
			}

			// ******************************** Finished ********************************

			Marshal.ReleaseComObject(comObj);

			comboBoxAudioMixer.Items.Clear();
			if (comboBoxVideoCard.SelectedItem != comboBoxAudioCard.SelectedItem) 
			{
			
				Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: WmMixer.GetMixers");

				string[] deviceIdentifiers = ((DsDevice)comboBoxAudioCard.SelectedItem).ToString().Split('\\');
				string mixerName = deviceIdentifiers[deviceIdentifiers.Length - 1].Replace(" input", " output");

				ArrayList mixers = WmMixer.GetMixers();

				WmMixer mixer = null;
				if (mixers != null) 
				{
					foreach (WmMixer m in mixers)
					{
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: found mixer: " + m.Name);
					}
					foreach (WmMixer m in mixers)
					{
						if (m.Name == mixerName)
						{
							mixer = m;
							break;
						}
					}
				}

				if (mixer == null)
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Could not find audio mixer device!");
	
				WmLine line = null;
				if (mixer != null)
				{
					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: mixer(" + mixer.Name + ").GetLines");
					ArrayList lines = mixer.GetLines();

					if (lines != null) 
					{
						foreach (WmLine l in lines)
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: found line: " + l.Name + ", targetName=" + l.Target.Name + ", targetType=" + l.Target.Type.ToString());
						}
						foreach (WmLine l in lines)
						{
							if (l.Target.Type == MixerLine_TargetType.WaveOut) 
							{
								line = l;
								break;
							}
						}
					}
					
					if (line == null) 
						Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: Could not find audio mixer line!");
				}

				if (line != null) 
				{

					Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: line(" + line.Name + ").GetSources");
					ArrayList sources = line.GetSources();

					if (sources != null) 
					{
						foreach (WmSource s in sources)
						{
							Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: found source: " + s.Name + ", targetName=" + s.Target.Name + ", targetType=" + s.Target.Type.ToString());
							comboBoxAudioMixer.Items.Add(s.Name);
							if (s.Name == "Line In") comboBoxAudioMixer.Text = s.Name;
						}
					}
				}

			}

			Logger.Verbose("RecorderConfig[" + this.GetHashCode() + "]: exit AudioCard.SelectedIndexChanged");
		}

		private void comboBoxAudioInput_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (comboBoxAudioMixer.Items.Contains(comboBoxAudioInput.Text))
			{
				comboBoxAudioMixer.Text = comboBoxAudioInput.Text;
			}
		}

		private void checkIfVideoAndAudioMatch()
		{
			bool match = comboBoxVideoCard.SelectedItem == comboBoxAudioCard.SelectedItem;
			checkBoxRenderVideoToAudio.Enabled = !match;
			checkBoxRenderAudioInPreview.Enabled = !match;
			if (match) 
			{
				checkBoxRenderVideoToAudio.Checked = false;
				checkBoxRenderAudioInPreview.Checked = true;
			}
		}

		#endregion

		#region Quality Settings
		private void buttonEdit_Click(object sender, System.EventArgs e)
		{
			string profileName = comboBoxQualityProfile.SelectedItem.ToString().Replace(" Quality", "");
			QualityConfig qualityConfig = new QualityConfig(mediaTypes, defaultMediaType, (Quality)qualityProfiles[profileName]);
			if (qualityConfig.ShowDialog() == DialogResult.OK) 
			{
				Quality quality = qualityConfig.GetQuality();
				if (quality == null)
					qualityProfiles.Remove(profileName);
				else
				{
					quality.profileName = profileName;
					qualityProfiles[profileName] = quality;
				}
			}
			qualityConfig.Dispose();
		}
		#endregion

	}
}
